<!-- -*-HTML-*- -->
<!-- $Id: DirComp.html.es,v 1.9 2006/03/28 02:33:51 markus Exp $ -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">

<html>
  <head>
    <title>DirComp - Documentaci&oacute;n</title>
    <meta name="description" content="Documentation of the DirComp-utility">
    <meta name="keywords" content="Documentation, Docu, DirComp, utility">

    <meta name="DC.Creator" content="Markus Schwab">
    <meta name="DC.Date" content="2002-04-05">
    <meta name="DC.Rights" content="Copyright (C) 2002 - 2006, distributed under the GNU General Public License">
  </head>

<!--
  Copyright (C) 2002 - 2006 Markus Schwab (g17m0@lycos.com)

  This is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-->

<body>

    <h1 align="center">DirComp - Utilidad para comparar dos directorios</h1>
    <hr size=2>

    <p>La utilidad <b>DirComp</b> compara dos directorios (y - si especificado
      - sus directorios bajos). Se puede compara para la existencia o para la
      fecha (del cambio &uacute;ltimo; siguente llamada "timestamp") o para el
      contenido.</p>

    <p>El exito est&aacute; el numero de los ficheros diferentes
      <a HRef="#footnoteReturnvalue"><sup>1</sup></a> (excepto especificado
      diferente).</p>

    <p>Modo de empleo:</p>

    <pre>    DirComp [&lt;Option(s)&gt; ...] directorio-original directorio-nuevo
    DirComp --daemon[[=]&lt;port&gt;]
    DirComp --server[[=]&lt;port&gt;]</pre>

    <p>con sentido siguente de los par&aacute;metros:</p>

    <pre>    Opci&oacute;n ....... Opci&oacute;nes de control por el programa
        -s, --recursive ....... Compara tambi&eacute;n directories bajos
        -E, --rec-equal ....... Compara solamente directorios bajos con nombres iguales
        -n, --no-changed ...... Supresa ficheros m&aacute;s joven o m&aacute;s viejo
        -N, --existing ........ Supresa ficheros borrado o nuevo
        -e, --equal ........... Visualiza tambi&eacute;n ficheros iguales
        -d, --show-dirs ....... Visualiza directorios con fechas diferentes
        -v, --verbose ......... Visualiza la fecha de los ficheros
        -H, --hidden .......... Incluye ficheros ocutles en la comparaci&oacute;n
        -c, --compare ......... Compara el contenido de ficheros (diferentes) (si est&aacute;n legible)
        -C, --force-compare ... Compara el contenido de todo los ficheros (si est&aacute;n legible)
        -i, --include ......... &lt;Fichero&gt;: Limita la comparaci&oacute;n a los ficheros especificados
        -x, --exclude ......... &lt;Fichero&gt;: Excluye los ficheros especificados de la comparaci&oacute;n
        -I, --include-dirs .... &lt;Ficheros&gt;: Limita la comparaci&oacute;n a los directorios especificados
        -X, --exclude-dirs .... &lt;Ficheros&gt;: Excluye los directorios especificados de la comparaci&oacute;n
        -t, --begin-time ...... &lt;Fecha&gt;: Frontera baja del espacio del tiempo para la comparaci&oacute;n
        -T, --end-time ........ &lt;Fecha&gt;: Frontera alta del espacio del tiempo para la comparaci&oacute;n
        -V, --version ......... Informa de la versi&oacute;n
        -q, --quiet ........... Modo silencioso (no muestra informaci&oacute;n inecesaria)
        -Q, --silent .......... Modo m&aacute;s silencioso (no muestra ninguna salida)
        -a, --action .......... &lt;Acci&oacute;n&gt;: Performa acci&oacute;n a los ficheros encontrados (que est&aacute;n mostrado)
        -A .................... &lt;Diferencia&gt;[&lt;Acci&oacute;n&gt;]: Performa acci&oacute;n a los ficheros encontrados que pegan a la diferencia pasado
        -S, --server .......... [&lt;puerto&gt;]: Inicia como servidor (en el primer plano)
	-D, --deamon .......... [&lt;puerto&gt;]: Inicia como servidor (en el fondo)
        -r, --ret-changed ..... Returna el numero de ficheros cambiados (m&aacute;s joven o m&aacute;s viejo)
        -R, --ret-new ......... Returna el numero de los ficheros borrados o nuevos
        -h, -?, --help ........ Muestra esta ayuda, y finaliza
    Originaldir ... Directorio de origen (basis de la comparaci&oacute;n)
    Comparedir .... Directorio de comparaci&oacute;n (directorio nuevo)
    </pre>

    <p>La llamada de</p>

    <pre>    DirComp -d Test1 Test2</pre>

    <p>pudr&iacute;a resultar en (por ejemplo)</p>

    <pre>    Viejo  : DirComp.cpp
    Nuevo  : DynArray.h
    Joven  : Test
    Nuevo  : Another
    Borrado: Other
    Borrado: DirComp.Mak</pre>

    <p>La opci&oacute;n <i>s</i> comparar&iacute;a tambi&eacute;n los
      directorios bajos Test, Other y Another. Parecido es la opci&oacute;n
      <i>E</i>, solamente que la compara directorios bajos que existen en
      ambos directorios.</p>

    <p>La opci&oacute;n <i>n</i> supresar&iacute;a los l&iacute;neas de
      Joven/Viejo; similario a la opci&oacute;n <i>N</i>, que
      supresar&iacute;a los l&iacute;neas de Nuevo/Borrado.</p>

    <p>Para muestrar tambi&eacute;n ficheros iguales (que tienen los mismos
       nombres y fechas (y contenido, si est&aacute; especificado)) la
       opci&oacute;n <i>e</i> tiene que especifado. Eso pudr&iacute;a resultar
       en salida como:</p>

    <Pre>    Igual  : DirComp.h</Pre>

    <p>Si la opci&oacute;n <i>d</i> no estar&iacute;a especificado, la
      l&iacute;nea "<i>Joven : Test </i>" no estar&iacute;a mostrado (eso es
      est&aacute;ndar, porque <i>Test</i> est&aacute; un directorio quienes
      diferencia de tiempo lo no importa generalmente).</p>

    <p>La opci&oacute;n <i>v</i> mostra el timestamp de todo los ficheros
      diferentes.  Si el fichero comparado esiste en ambos directorios, los
      timestamps de los est&aacute;n mostrados.</p>

    <p>La opci&oacute;n <i>c</i> compara los contenido de ficheros con
       timestamps diferentes (y dimensi&oacute;nes iguales) y mostralos
       solamente si los est&aacute;n diferentes tambi&eacute;n.</p>

    <p>La opci&oacute;n <i>C</i> compara los contenido de ficheros independete
       de sus timestamps. Ficheros diferentes (con timestamps iguales) causan
       la salida siguenta:</p>

    <Pre>    Distinto: DirComp.cpp</Pre>

    <p>Ficheros ocultos pueden ser incluido por la comparaci&oacute;n con la
      opci&oacute;n <i>H</i>. Cuales ficheros los son dependende del sistema
      operativo; Unices oscuran ficheros que empezan con un punto (.), otros
      (como OS/2 o DOS y su colecci&oacute;n grafico de bugs) tienen un
      atributo especial para marcarlos.</p>

    <p>La opci&oacute;n <i>i</i> restricta la comparaci&oacute;n a
      <b>ficheros</b> (no directorios!), que pegan la especificaci&oacute;n
      pasado. Los fijadores de posici&oacute;nes asterisco (*) (significa cada
      numero de todos los letras) y el signo de interrogaci&oacute;n (?)
      (significa cualquiera letra solo) est&aacute;n suportado. Adem&aacute;s
      est&aacute; posible especificar las letras validas en chorchetes ([) y
      (]), o por detallarlos o por especificar las fronteras, seperado por un
      menos (-). Para invertir esa selecci&oacute;n usa una primera caret
      (^).</p>

    <p>An&aacute;logo hay la opci&oacute;n <i>x</i> que excluya ficheros de la
      comparaci&oacute;n.</p>

    <p>Especificaci&oacute;nes pueden ser combinado o por separadolos con la
      letra seperado del camino del sistema operativo (dos puntos (:) en
      Unices; punto y coma (;) en OS/2, DOS y Windoze) o por volver a usar la
      opci&oacute;n respectiva.</p>

    <Pre>    p.e. -i*.cpp -i *.h -x*[^1-9].cpp:[A-EXYZ]*.cpp     <i>para Unices</i>
    p.e. -i*.cpp -i *.h -x*[^1-9].cpp;[A-EXYZ]*.cpp     <i>para OS/2, DOS</i></Pre>

    <p>Esas opci&oacute;nes est&aacute;n inspectado de derecha a izquierda,
      entonces esribe las m&aacute;s generals al principio; si falta una
      opci&oacute;n para incluir ficheros, primero todo los
      ficheros/directorios est&aacute;n incluido (antes excluirlos).</p>

    <p>Similar a las dos opci&oacute;n ultimas, <i>I</i> and <i>X</i>
      restrictan la comparaci&oacute;n a los directorios especificado.</p>

    <p>fijadores de posici&oacute;nes est&aacute;n suportado en m&aacute;s
      nivels para directorios; por ejemplo (para Unices) -I*/?0 incluye todo
      los directorios en segundo nivel que terminan con un 0; -XLinux/* no
      compara todo los directorios en el directorio Linux.</p>

    <p>Si (al menos) uno de las ultimas opci&oacute;nes est&aacute;
      especificado, directorios bajos est&aacute;n comparado automatico
      (incluso si la opci&oacute;n <i>s</i> no estuvo especificado; hace
      sentido, si no?).</p>

    <p>Las opci&oacute;nes <i>t</i> y <i>T</i> restrictan la
      comparaci&oacute;n a ficheros que est&aacute;n en la &aacute;rea del los
      tiempos especificados (incluido los fronteras); <i>t</i> especifica la
      frontera baja y <i>T</i> la alta.</p>

    <p>Esas opci&oacute;nes expectan la fecha en el formato
      <i>D.M.AAAA-h:m:s</i> como parameter; cada de los valores puede ser
      serperado con cada letra non-numerico. Nota: <b>No</b> usa ceros
      primeros!</p>

    <p>Nota: Si hay dos ficheros con nombres mismos, donde solamente uno
      est&aacute; entre las fronteras, lo est&aacute; reportado como nuevo (or
      borrado); ficheros afueros del los fronteras no existen (por lo menos
      para la utilitad)!</p>

    <p>La opci&oacute;n <i>V</i> mostra informaciones adicionales sobre el
      programa (como fecha de la compilaci&oacute;n y informaci&oacute;n sobre
      el escritor) y una descripci&oacute;n m&aacute;s detallado durante
      mostra la ayuda.</p>

    <p>La opci&oacute;n <i>q</i> supresa las l&iacute;neas adicionales
      (excepto - por supuesto - para la ayuda) y restricta por eso las salidas
      de informaciones sobre los ficheros (seg&uacute;n los otros
      opci&oacute;nes). Lo sirve para procesar las salidos automatico.</p>

    <p>&Uacute;til para procesar automatico son tambi&eacute;n las
      opci&oacute;nes <i>r</i>, <i>R</i> y <i>Q</i>. La ultima supresa todas
      las salidas del programa; la principia returna el numero del los
      ficheros cambiados (no los nuevos o borrados exactamente) y la segunda
      el numero de los nuevos o borrados (por defecto es todos los ficheros
      diferentes)<a HRef="#footnoteReturnvalue"><sup>1</sup></a>.</p>

    <p>Las opci&oacute;nes <i>a</i> y <i>A</i> permitan de especifar
      acci&oacute;nes, que deben ser executado a los ficheros diferentes. En
      los paramaters para las acci&oacute;nes los fijadores de posici&oacute;n
      siguentes son cambiado:</p>

    <table border="1" cellpadding="3">
      <tr><th>Fijadores de posici&oacute;n</th><th>Cambiados con</th></tr>
      <tr><td><p align="center">{OP}</td><td>Camino del fichero original</td></tr>
      <tr><td><p align="center">{OF}</td><td>Camino y nombre del fichero original</td></tr>
      <tr><td><p align="center">{CP}</td><td>Camino del fichero nuevo</td></tr>
      <tr><td><p align="center">{CF}</td><td>Camino y nombre del fichero nuevo</td></tr>
    </table>

    <p>La opci&oacute;n <I>A</I> tambi&eacute;n necesita una necesita una
      especificaci&oacute;n, para cual ficheros la acci&oacute;n debe ser
      ejecutado. Valores posibles (que pueden ser conectado con OR) son:</p>

    <table border="1" cellpadding="3">
      <tr><th>Change-ID</th><th>Associated files</th></tr>
      <tr><td><p align="center">1</td><td>Ficheros m&aacute;s joven</td></tr>
      <tr><td><p align="center">2</td><td>Ficheros m&aacute;s viejo</td></tr>
      <tr><td><p align="center">4</td><td>Ficheros diferentes (mismo timestamp pero 
	  contenido  diferente seg&uacute;n la opci&oacute;n <i>C</i>)</td></tr>
      <tr><td><p align="center">8</td><td>Ficheros iguales</td></tr>
      <tr><td><p align="center">16</td><td>Ficheros borrados</td></tr>
      <tr><td><p align="center">32</td><td>Ficheros nuevos</td></tr>
    </table>

    <p>Si menos (-) es especificado como acci&oacute;n (o ninguno por <I>A</I>) no acci&oacute;n es 
      performado (para actualizar el directorio original pudr&iacute;as usar los commandos
      (equivalentes)):</p>

    <pre>    DirComp &quot;-acp {CF} {OP}&quot; -A26 . ..
    DirComp &quot;-A37cp {CF} {OP} +1&quot; . ..</pre>

    <p>Directorios pueden ser comparado sobre un red. Para hacerlo la utilidad
      tiene que iniciado como servidor (las opci&oacute;nes <i>S</i> o
      <i>D</i>) on la maquina distante. El directorio es especificado como
      &lt;<i>servidor</i>&gt;:&lt;<i>directorio</i>&gt;[:&lt;<i>puerto</i>&gt;].
      Un ejemplo es:</p>

    <pre>    DirComp /usr/local/src/DirComp prod:/usr/local/DirComp:4711</pre>

    <p>Al servidor <i>prod</i> la utilidad tiene que ser iniciado como:</p>

    <pre>    DirComp -D 4711</pre>

    <p>Para mostrar errors ocurado (y no solamente escribirlos al system-log),
      la opci&oacute;n D podr&iacute;a ser cambiado con S. El puerto por
      defecto para la comunicaci&oacute;n es 31336.</p>

    <p>Usa esa caracter&iacute;stica con cuidado porque la pudr&iacute;a
      producir informaci&oacute;nes sobre la estructura de los directorios y
      los programas instalados (y sus versiones) a un agresor! Lo es la razon
      porque esa cualidad tiene que ser activado durante la
      compilaci&oacute;n.</p>

    <p><hr size=1 noshade>
    <a Name="footnoteReturnvalue">1: Nota: Unos systemas operativos
      restricta el valor del retorno (DOS: 1 &uacute;nico byte) y si lo
      pasa se consegue numeros falsos (y si lo resulta a un valor de cero
      incluso un sentido falso).</p>

    <hr size=2 noshade>
    <address>
      <a href="mailto:g17m0@lycos.com">Markus Schwab (g17m0@lycos.com)</a>
    </address>
</body>
</html>
